﻿namespace IsPatternBasics {
	internal class Program {
		static void Main(string[] args) {
			int? b = null;
			Console.WriteLine($"b = {b}");
			if (b == null) {
				Console.WriteLine("b is null");
			}
			if (b is null) {
				Console.WriteLine("b is null");
			}

			b = 20;
			Console.WriteLine($"b = {b}");
			if (b != null) {
				Console.WriteLine("b is not null");
			}
			if (b is not null) {
				Console.WriteLine("b is not null");
			}

			//

			TextWriter? w = new StreamWriter("Dummy.txt");
			if (w is not StreamWriter) {
				Console.WriteLine("0: w is not StreamWriter");
			}

			if (w is not null and StreamWriter) {
				Console.WriteLine("1: w is not null && is StreamWriter");
			}
			w = null;
			if (w is not null and StreamWriter) {
				Console.WriteLine("2: w is not null && is StreamWriter");
			}
			w = new StreamWriter("Dummy2.txt");
			if (w is StreamWriter) {
				Console.WriteLine("3: w is StreamWriter (and not null)");
			}

			//

			if (b != null && b > 10) {
				Console.WriteLine("b is not null & is > 10");
			}
			if (b is not null and > 10) {
				Console.WriteLine("b is not null & is > 10");
			}

			if (b == null || (b > 10 && b < 3000)) {
				Console.WriteLine("b is null | (is > 10 & < 3000)");
			}
			if (b is null or (> 10 and < 3000)) {
				Console.WriteLine("b is null | (is > 10 & < 3000)");
			}
		}
	}
}